//REITANO ANGELO matricola n.289211

#include "mylib.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>


static struct Terra * percorso = NULL;//puntatore al primo elemento della lista din.
static struct Terra * ultima_terra = NULL;//puntatore ad ultimo elemento lista
static struct Oberon oberon;//variabile che rappresenta lo stato del giocatore
static struct Terra * posizione_oberon= NULL;//rappresenta la posizione del giocatore nel mondo


static int fine=0;//assume 0 se non è stato chiuso il percorso, 1 se è stato chiuso, -1 se oberon finisce i livelli

//stringhe per "conversione" enum-stringa 
static char * tipo_terra_strings [] ={"villaggio","pianura","palude","foresta","deserto"};

static char * tipo_mostro_strings [] ={"nessuno","scheletro","lupo","orco","drago"};


//prototipi di funzioni necessarie
static void crea_terra();
static void canc_terra();
static void stampa_percorso();
static int chiudi_percorso();
static void avanza();
static void prendi_tesoro();
static void usa_pozione();
static void combatti();
static void distruggi_terra();


//prototipi di funzioni personali
static int getEnumTerra(char * string);

//first fa da bool e indica se quella che si sta inserendo è la prima terra
static int getEnumMostro(char * string, int terra, int first);

static char * getStringTerra(int);

static char * getStringMostro(int);

static int getPsMostro(int mostro);

static void oberon_attacca(int * ps);

static void mostro_attacca();

//stampa menu' per gestire il percorso
void crea_percorso(){
    if(fine!=0){
        printf("Il percorso è già stato creato ed e' impossibile modificarlo.....\n"); 
    }
    else{
        int choose=0;
        do{
        
            printf(">$ Inserisci l'operazione da effettuare \n\n");
            printf(" 1. Inserisci terra,\n 2. Cancella ultima terra, \n 3. Stampa percorso, \n 4. Chiudi percorso.\n");
            //inserimento scelta operazione
            printf(">$");
            scanf("%d",&choose);

            system("clear");
            switch(choose){
                case 1:
                    crea_terra();
                    break;

                case 2:
                    canc_terra();
                    break;

                case 3:
                    stampa_percorso();
                    break;

                case 4:
                    choose=chiudi_percorso();
                    break;

                default:
                    printf("Opzione non valida.....\n");
                    break;
            }
        }while(choose!=4);
    }
}

//crea una nuova terra
static void crea_terra(){
    system("clear");
    char terreno [15] ;//stringhe usate per salvare i valori inseriti da tastiera
    char mostro [15] ;
    int first;
    if( percorso == NULL){//in caso ancora non sia stato creato il percorso
        //printf("Non è ancora presente alcuna terra nel percorso\n");//debug
        ultima_terra=percorso=(struct Terra *) malloc(sizeof(struct Terra));//alloco memoria per una struttura
        percorso->terra_successiva=NULL;
        first=1;
    }
    else{
        //scanf("%s",mostro);//debug
        //printf("E' gia'  presente una o piu' terre nel percorso\n");//debug
        ultima_terra->terra_successiva=(struct Terra *) malloc(sizeof(struct Terra));//alloco memoria per una struttura
        //scanf("%s",mostro);//debug
        ultima_terra=ultima_terra->terra_successiva;
        ultima_terra->terra_successiva= NULL;
        first=0;
        
    }
    
    printf("Inserisci le caratteristiche di questa terra \n");
        
    //inserimento del tipo della terra
    do{
        printf("Tipo Terra (villaggio,pianura,palude,foresta,deserto) : ");
        scanf("%s",terreno);
            
        ultima_terra->terra = getEnumTerra(terreno);//restituisce un intero
            
    }while(ultima_terra->terra==-1);//cicla finche' il valore non è valido
    
    //inserimento del tipo di mostro presente nella terra
    do{
        printf("Tipo Mostro (nessuno,scheletro,lupo,orco,drago): ");
        scanf("%s",mostro);
            
        ultima_terra->mostro = getEnumMostro(mostro,(int)ultima_terra->terra,first);//restituisce un intero
            
    }while(ultima_terra->mostro==-1);//cicla finche' il valore non è valido
    
    //inserimento della quantita di oro nel tesoro
    do{
        printf("Oro Tesoro : ");
        scanf("%hd",&(ultima_terra->tesoro));
            
        if(ultima_terra->tesoro>10 && ultima_terra->terra==0){
            printf("Non ci possono essere più di 10 monete nei villaggi!\n");
            ultima_terra->tesoro=-1;
        }
    }while(ultima_terra->tesoro<0);//cicla finche' il valore non è valido
        
    system("clear");
    
}

//restituisce il valore intero a cui corrisponde la stringa delle terre inserita da tastiera
static int getEnumTerra(char * string){
    int result=-1;
    for(int i=0; i<5; i++){//cicla finche non trova il valore intero desiderato
        if(strcmp(tipo_terra_strings[i],string)==0){
            result=i;
            break;
        }
    }
    // in caso l'input non sia valido restituisce errore
    if(result==-1)
        printf("\n>$ Tipo di Terra non valido....riprova\n");
    
    return result;
}

//restituisce il valore intero a cui corrisponde la stringa dei mostri inserita
    //da tastiera e controlla che il valore sia coerente alla terra
static int getEnumMostro(char * string,int terra,int first){
    int result=-1;
    for(int i=0; i<5; i++){//cicla finche non trova il valore deisderato
        if(strcmp(tipo_mostro_strings[i],string)==0){
            result=i;
            break;
        }
    }
    
    if(first==1 && result>0){//se la terra e' la prima ed il mostro e' diverso da 
        
        printf("\n>$ Errore non ci possono essere mostri nella prima terra!\n\n");
        result=-1;
    
    }else if(first==0 && result<0){//se non e' la prima terra e l'input non e' valido
        
       printf("\n>$ Errore valore non riconosciuto!\n\n"); 
    
    } else{//se la terra non e' la prima ma l'input e' valido
    
        switch (terra){
            case 0://villaggio
                if(result>0){//in caso sia un valore diverso da 0
                    printf("\n>$ Errore non ci possono essere mostri nei villaggi!\n\n");
                    result=-1;
                }
                break;

            case 2://palude
                if(result==1){
                    printf("\n>$ Errore gli scheletri non possono essere presenti nelle paludi!\n\n");
                    result=-1;
                }else if(result==2){
                    printf("\n>$ I lupi possono essere solo presenti nelle pianure o nelle foreste!\n\n");
                    result=-1;
                }

                break;

            case 4://Deserto
                
                if(result==3){
                    printf("\n>$ Errore gli orchi non possono essere presenti nei deserti!\n\n");
                    result=-1;
                }else if(result==2){
                    printf("\n>$ I lupi possono essere solo presenti nelle pianure o nelle foreste!\n\n");
                    result=-1;
                }
                break;
        }
        
    }
    
    return result;
}

//elimina l'ultima terra nella lista
static void canc_terra(){
    system("clear");
    if(percorso==NULL){
        
        printf(">$ Non è presente alcuna terra, il percorso è vuoto....\n");
        
    }else{
        struct Terra * temp= percorso, *last =percorso;
        
        
        do{
            if(temp->terra_successiva==NULL){//se l'indirizzo successivo dell'elemento della lista è null
                if(temp==percorso){//se l'elemento puntato da temp equivale all inizio del percorso
                    free(percorso);
                    percorso=NULL;
                    ultima_terra=NULL;
                }else{//altrimenti
                    ultima_terra=last;// si assegna ad ultima terra il penultimo elemento della lista

                    if(ultima_terra==percorso){//se il penultimo elemento punta all inizio del percorso
                        free(temp);
                        ultima_terra=percorso;
                        percorso->terra_successiva=NULL;
                    }else{//eliminazione dell'ultimo elemento
                        free(temp);//si elimina l'ultimo elemento
                        ultima_terra->terra_successiva=NULL;
                    }
                }
                break;
            }else{//si continua a ciclare
                last=temp;//last diventa sempre l'elemento temp -1 nella lista
                temp=temp->terra_successiva;
            }
            
        }while(1);
        
        printf(">$ Ultima Terra Eliminata......\n");
    }
    
}

//stampa tutte le terre presenti nella lista
static void stampa_percorso(){
    system("clear");
    if(percorso==NULL){
        
        printf(">$ Non è presente alcuna terra, il percorso è vuoto....\n");
        
    }else{
        struct Terra * temp=percorso;//puntatore usato per scorrere la lista
        
        do{
            printf("Terra : %s \n",getStringTerra((int)temp->terra));
            printf("Mostro : %s \n",getStringMostro((int)temp->mostro));
            printf("Valore Tesoro: %hd \n",temp->tesoro);
            
            printf("\t|\n\t|\n\t|\n\tv\n");
            
            if(temp->terra_successiva==NULL){
                break;
            }else{
                temp=temp->terra_successiva;
            }
            
        }while(1);
         printf("       Fine\n");
        printf("\n \n \n");
    }
    
}

//restituisce la stringa a cui corrisponde il valore enum riguardo alle terre
static char * getStringTerra(int v){
    return tipo_terra_strings[v];
}

//restituisce la stringa a cui corrisponde il valore enum riguardo ai mostri
static char * getStringMostro(int v){
    return tipo_mostro_strings[v];
}

//esce dalla modalità "crea percorso"
static int chiudi_percorso(){
    system("clear");
    
    printf(">$ Sicuro? una volta usciti dalla modalita' \"crea percorso\" non potrai più rientrare fino alla chiusura del gioco....\n");
    char temp='0';
    int r;
    do{
        printf("(S/N) >$");
        scanf(" %c",&temp);

        if(temp=='N'){
            r=0;
            system("clear");
        }else if(temp=='S'){
            if(percorso==NULL){
                system("clear");
                printf(">$ Impossibile uscire, deve essere presente almeno una terra\n");
                r=0;
            }else{
                r= 4;
                fine=1;
                system("clear");
                printf(">$ Chiusura modalita' crea percorso....\n");
            }
        }else{
            system("clear");
            printf(">$ Valore non riconosciuto....reinserisci la tua risposta\n");
        }

    }while((temp!='N')&&(temp!='S'));
    return r;
}

//viene usata per muovere oberon lungo il percorso
void muovi_oberon(){
    srand(time(NULL));//inizializzazione del seme per il combattimento
    if(fine==0){
        printf("Il percorso non è stato ancora creato e chiuso...... \n"); 
    }else if(fine==-1){
        printf("non puoi rigiocare...\n");
    }else{
        oberon.borsa_oro=10;
        oberon.punti_ferita=5;
        oberon.incantesimi=2;
        oberon.pozione_cura=1;

        int choose=0;
        posizione_oberon=percorso;
        do{
            if( fine==-1){
                printf("Il tuo viaggio  si e' concluso!\n\n");
                choose=6;
            }else{
                printf("Ti trovi in un/a %s\n",getStringTerra(posizione_oberon->terra));
                printf("Nemico: %s\n",getStringMostro((int)posizione_oberon->mostro));
                printf("Valore Tesoro: %d\n\n",posizione_oberon->tesoro);

                printf("Hai %d P.S., %d unita' di oro, ti rimangono %d magie , n.%d pozioni curative\n\n",oberon.punti_ferita,oberon.borsa_oro,oberon.incantesimi,oberon.pozione_cura);

                printf(">$ Inserisci l'operazione da effettuare \n\n");
                printf(" 1. Avanza,\n 2. Prendi Tesoro, \n 3. Usa Pozione, \n 4. Combatti,\n 5. Distruggi Terra Successiva\n");
                //inserimento scelta operazione
                printf(">$");
                scanf("%d",&choose);

                //system("clear");
                switch(choose){
                    case 1:
                        avanza();
                        break;

                    case 2:
                        prendi_tesoro();
                        break;

                    case 3:
                        usa_pozione();
                        break;

                    case 4:
                        combatti();
                        break;

                    case 5:
                        distruggi_terra();
                        break;

                    default:
                        printf("Opzione non valida.....\n");
                        break;
                }
            }
        }while(choose!=6);
    }
}

//muove oberon verso la terra successiva
static void avanza(){
    system("clear");
    if(posizione_oberon->mostro==4){
        printf("In questa terra e' presente un orribile drago! Non puoi lasciare gli abitanti soli!\n");
    }else if(posizione_oberon->terra_successiva==NULL){
        system("clear");
        fine=-1;
    }else{
        printf("Ti muovi verso la prossima terra...\n");
        posizione_oberon = posizione_oberon->terra_successiva;
    }
    
}

//prende il tesoro presente nella terra
static void prendi_tesoro(){
    system("clear");
    if(posizione_oberon->mostro==0){
        if(oberon.borsa_oro>=500){
            printf("La borsa e' colma! Non riesci ad inserire dentro una sola moneta!\n");
        }else if((oberon.borsa_oro+posizione_oberon->tesoro)>=500){
            oberon.borsa_oro+=posizione_oberon->tesoro;
            posizione_oberon->tesoro=oberon.borsa_oro-500;
            oberon.borsa_oro=500;
        }else if(posizione_oberon->tesoro==0){
            printf("Il baule del tesoro e' vuoto...oppure l'hai gia' ripulito, non ricordi?\n");
        }else{
            oberon.borsa_oro+=posizione_oberon->tesoro;
            posizione_oberon->tesoro=0;
        }
    }else
        printf("Il tesoro e' sorvegliato da un %s, dovrai sconfiggerlo....\n",getStringMostro(posizione_oberon->mostro));
    
}

//
static void usa_pozione(){
    system("clear");
    if(oberon.pozione_cura==0){
        printf("Non hai piu' pozioni nella borsa! \n");
    }else{
        oberon.punti_ferita+=5;
        oberon.pozione_cura--;
    }
}

//
static void combatti(){
    system("clear");
    int choose=-1;
    if(posizione_oberon->mostro==0){//se non è presente alcun mostro
        printf("Non e' presente alcun mostro....\n");
    }else{//altrimenti
        char * nome_mostro=getStringMostro((int)posizione_oberon->mostro);
        printf("Hai deciso di combattere il mostro! Il/Lo %s si avvicina...\n",nome_mostro);
               
        int ps_mostro=getPsMostro((int)posizione_oberon->mostro);
               
        do{
            if(choose!=-1){
                printf("Il mostro attacca!\n");
                mostro_attacca();
                choose=-1;
                
            }else if(oberon.punti_ferita>0){
                
                printf("\n    |Oberon|            |%s|\n     P.S.=%d              P.S=%d\n     Magie:%d\n     Pozioni=%d\n\n",nome_mostro,oberon.punti_ferita,ps_mostro,oberon.incantesimi,oberon.pozione_cura);
                printf("Decidi cosa fare :\n 1. Usa Magia \n 2. Attacca\n");
                
                printf(">$");
                scanf("%d", &choose);
                system("clear");
                switch(choose){
                    case 1:
                        if(oberon.incantesimi>=1){
                            oberon.incantesimi--;
                            ps_mostro=0;
                            printf("Oberon decide di usare uno dei suoi incantesimi!\nIl mostro muore sul colpo!\n");
                        }else{
                            printf("Non hai più incantesimi...\n");
                        }

                        break;
                    case 2:
                        oberon_attacca(&ps_mostro);
                        break;
                }
            }
        }while(ps_mostro>0 && oberon.punti_ferita>0);
        posizione_oberon->mostro=0;
        
        if(oberon.punti_ferita<=0){
            printf("\nOberon non e' sopravvisuto all' attacco...la partita e' terminata....\n\n");
            fine=-1;
        }
        
        else
            printf("Il mostro e' stato sconfitto e la pace riportata in questa terra....\n");
    }
}

//
static int getPsMostro(int mostro){
    int temp;
    switch(mostro){
        case 1:
            temp=2;
            break;
        case 2:
            temp=1;
            break;
        case 3:
            temp=3;
            break;
        case 4:
            temp=5;
            break;
    }
    return temp;
}

//
static void oberon_attacca(int * ps){
    //system("clear");
    if(rand()%100>60){
        *ps-=3;
        printf(" Oberon attacca! Colpo critico, 3 p.s. tolti!\n");
    }else{
        printf(" Oberon attacca! Ma l'unica cosa che riesce a colpire e' l aria....\n");
    } 
    
}

//
static void mostro_attacca(){
    //system("clear");
    if(rand()%100>50){
        oberon.punti_ferita-=(short)posizione_oberon->mostro+1;
        printf(" Colpo riuscito!, %d  p.s. di danno ricevuti!!\n",(int)posizione_oberon->mostro+1);
    }else{
        printf(" Ma oberon riesce a schivare!\n");
    } 
    
}

//distrugge la terra successiva
static void distruggi_terra(){
    static int used=0;
    system("clear");
    if(used==1){
        printf("Non puoi riutilizzare di nuovo questa magia!\n");
    }else{
        used=1;
        if(posizione_oberon->terra_successiva!=NULL){
            struct Terra * temp = posizione_oberon->terra_successiva;
            posizione_oberon->terra_successiva=temp->terra_successiva;
            free(temp);
            printf("La terra successiva e' stata distrutta!\n");
        }else{
            printf("Non ci sono terre dopo questa!\n");
        }
    }
    
}

//
void termina_gioco(){
    if(percorso!=NULL){
        struct Terra *pnt = percorso, * temp = pnt;
        while(temp->terra_successiva!=NULL){
            pnt=temp;
            temp=temp->terra_successiva;
            free(pnt);
        }
        free(temp);
    }
}